﻿Public Class Form1

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Declarations ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Dim uart_in As Byte
    Dim uart_out(1) As Byte
    Dim laser_stat As Boolean = False
    Dim LED_stat As Boolean = False
    Dim binstring(8) As Char
    Dim i As Byte

    Delegate Sub inputprocessCallback(ByVal [data] As Byte)

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next three subrutines handle connecting to the serial port ''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub connect_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles connect_button.Click
        Try
            SerialPort1.Open()
            Reset()
            disconnect_button.Enabled = True
            connect_button.Enabled = False
            ComboBox1.Enabled = False
        Catch unauthorized As UnauthorizedAccessException
            MessageBox.Show("This program is forbidden access to the COM port. It may be in use by another application, or blocked for security reasons.")
        Catch exception As IO.IOException
            MessageBox.Show("Selected COM port wasn't found on this machine.")
        Catch arg As InvalidOperationException
            MessageBox.Show("Selected COM port is already open.")
        End Try
    End Sub

    Private Sub disconnect_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles disconnect_button.Click
        Try
            connect_button.Enabled = True
            disconnect_button.Enabled = False
            ComboBox1.Enabled = True
            SerialPort1.Close()
        Catch invalid As InvalidOperationException
            MessageBox.Show("Selected COM port is already closed.")
        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SerialPort1.PortName = ComboBox1.Text
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next two rutines determine the byte to send out '''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub PressKey(ByVal data As Byte, ByVal mask As Byte)
        If (SerialPort1.IsOpen) Then
            Try
                uart_out(0) = (data Or uart_out(0))
                uart_out(0) = (mask And uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            End Try
        Else
            MessageBox.Show("Serial Port is disconnected.")
        End If
    End Sub

    Private Sub ReleaseKey(ByVal data As Byte)
        If (SerialPort1.IsOpen) Then
            Try
                uart_out(0) = (data And uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            End Try
        Else
            MessageBox.Show("Serial Port is disconnected.")
        End If
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Handles label click '''''''''''''''''''''''''''''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub LinkLabel1_LinkClicked_1(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        System.Diagnostics.Process.Start("http://www.google.com/search?hl=en&q=uzzors2k")
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next batch of rutines handle clicking the buttons '''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub right_button_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles right_button.MouseDown
        PressKey(8, 200)
    End Sub

    Private Sub left_button_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles left_button.MouseDown
        PressKey(4, 196)
    End Sub

    Private Sub right_button_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles right_button.MouseUp
        ReleaseKey(244)
    End Sub

    Private Sub left_button_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles left_button.MouseUp
        ReleaseKey(248)
    End Sub

    Private Sub up_button_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles up_button.MouseDown
        PressKey(16, 208)
    End Sub

    Private Sub down_button_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles down_button.MouseDown
        PressKey(32, 224)
    End Sub

    Private Sub up_button_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles up_button.MouseUp
        ReleaseKey(236)
    End Sub

    Private Sub down_button_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles down_button.MouseUp
        ReleaseKey(220)
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next two rutines handle key-pressing keys '''''''''''''''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If e.KeyCode = Keys.W Then
            up_button.Enabled = False
            down_button.Enabled = False
            PressKey(16, 220)
        End If
        If e.KeyCode = Keys.S Then
            down_button.Enabled = False
            up_button.Enabled = False
            PressKey(32, 236)
        End If
        If e.KeyCode = Keys.A Then
            left_button.Enabled = False
            right_button.Enabled = False
            PressKey(4, 244)
        End If
        If e.KeyCode = Keys.D Then
            right_button.Enabled = False
            left_button.Enabled = False
            PressKey(8, 248)
        End If
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        If e.KeyCode = Keys.W Then
            up_button.Enabled = True
            down_button.Enabled = True
            ReleaseKey(236)
        End If
        If e.KeyCode = Keys.S Then
            down_button.Enabled = True
            up_button.Enabled = True
            ReleaseKey(220)
        End If
        If e.KeyCode = Keys.A Then
            left_button.Enabled = True
            right_button.Enabled = True
            ReleaseKey(248)
        End If
        If e.KeyCode = Keys.D Then
            right_button.Enabled = True
            left_button.Enabled = True
            ReleaseKey(244)
        End If
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next two rutines handle controlling the Laser and LED '''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub laser_checkbox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles laser_checkbox.CheckedChanged
        If laser_stat Then
            Try
                uart_out(0) = (192 And uart_out(0))
                uart_out(0) = (127 And uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
                laser_stat = False
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            Catch closed As InvalidOperationException
                MessageBox.Show("Serial Port is disconnected.")
            End Try
        Else
            Try
                uart_out(0) = (192 And uart_out(0))
                uart_out(0) = (128 Or uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
                laser_stat = True
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            Catch closed As InvalidOperationException
                MessageBox.Show("Serial Port is disconnected.")
            End Try
        End If
    End Sub

    Private Sub LED_checkbox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LED_checkbox.CheckedChanged
        If LED_stat Then
            Try
                uart_out(0) = (192 And uart_out(0))
                uart_out(0) = (191 And uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
                LED_stat = False
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            Catch closed As InvalidOperationException
                MessageBox.Show("Serial Port is disconnected.")
            End Try
        Else
            Try
                uart_out(0) = (192 And uart_out(0))
                uart_out(0) = (64 Or uart_out(0))
                SerialPort1.Write(uart_out, 0, 1)
                LED_stat = True
            Catch exception As TimeoutException
                MessageBox.Show("The connection timed out. Check hardware connection to device or select a different port.")
            Catch closed As InvalidOperationException
                MessageBox.Show("Serial Port is disconnected.")
            End Try
        End If
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next two rutines handle the reset button and reset function '
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub reset_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles reset_button.Click
        Reset()
    End Sub

    Private Sub Reset()
        uart_out(0) = 0
        uart_in = 0
        laser_stat = 0
        LED_stat = 0
        inputprocess(uart_in)
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' The next two rutines receive serial bytes and display them ''''''
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        uart_in = SerialPort1.ReadByte
        If (feedback.InvokeRequired) Then
            Dim x As New inputprocessCallback(AddressOf inputprocess)
            feedback.Invoke(x, uart_in)
        Else
            inputprocess(uart_in)
        End If
    End Sub

    Private Sub inputprocess(ByVal [data] As Byte)
        ' creates binary string from decimal byte
        uart_out(0) = [data]
        'feedback.Text = [data].ToString
        i = 0
        Do Until i > 7
            If [data] >= (2 ^ (7 - i)) Then
                binstring(i) = "1"
                [data] = ([data] - (2 ^ (7 - i)))
            Else
                binstring(i) = "0"
            End If
            i = (i + 1)
        Loop
        feedback.Text = binstring
    End Sub

End Class
